<?php 
/**
* Plug-in do MAMBOLETO Joomla! para VirtueMart
* @author Fernando Soares ( www.fernandosoares.com.br )
* @version 6.0, Setembro/2007
*
* Mamboleto:	http://www.fernandosoares.com.br
*
* VirtueMart: 	http://www.virtuemart.net
* 
* @package Joomla! 1.1.12 e Virtuemart 1.0.12

Baseado no trabalho de 	Matheus Mendes e Pedro Mller ( contato@mambopros.net )
				Messuka ( messuka@messuka.com.br )
				Metasig http://www.metasig.com.br

*/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

class ps_mamboleto {
    var $payment_code = "MBT"; // cdigo desse pagamento
    var $classname = "ps_mamboleto"; //nome da classe
    
    function show_configuration() { 
        
        global $sess,$VM_LANG;
        $payment_method_id = mosGetParam( $_REQUEST, 'payment_method_id', null );
        /** Read current Configuration ***/
        require_once(CLASSPATH ."payment/".$this->classname.".cfg.php");
?>

        <table>
          <tr>
          <td><strong>Banco a usar:</strong></td>
              <td>
                <select name="MAMBOLETO_ID" class="inputbox" >
                <option <?php if (MAMBOLETO_ID == '1') echo "selected=\"selected\""; ?> value="1">Unibanco</option>
                <option <?php if (MAMBOLETO_ID == '2') echo "selected=\"selected\""; ?> value="2">HSBC</option>
                <option <?php if (MAMBOLETO_ID == '3') echo "selected=\"selected\""; ?> value="3">Bradesco</option>
                <option <?php if (MAMBOLETO_ID == '4') echo "selected=\"selected\""; ?> value="4">Santander</option>
                <option <?php if (MAMBOLETO_ID == '5') echo "selected=\"selected\""; ?> value="5">Caixa Econ. Federal</option>
                <option <?php if (MAMBOLETO_ID == '6') echo "selected=\"selected\""; ?> value="6">Banco do Brasil</option>
                <option <?php if (MAMBOLETO_ID == '7') echo "selected=\"selected\""; ?> value="7">Banco Itau S.A.</option>
                <option <?php if (MAMBOLETO_ID == '8') echo "selected=\"selected\""; ?> value="8">BANRISUL</option>
                <option <?php if (MAMBOLETO_ID == '9') echo "selected=\"selected\""; ?> value="9">Real</option>
                <option <?php if (MAMBOLETO_ID == '10') echo "selected=\"selected\""; ?> value="10">Mercantil</option>
                </select>
              </td>
          <td>Selecione aqui o banco para o qual voc ir gerar os boletos bancrios.</td>
          </tr>
          <tr>
          	<td><strong>Enviar por e-mail: </strong></td>
			<td>
			<select name="EMAIL_ID" class="inputbox" >
			<option <?php if (EMAIL_ID == '1') echo "selected=\"selected\""; ?> value="1">Sim</option>
			<option <?php if (EMAIL_ID == '0') echo "selected=\"selected\""; ?> value="0">No</option>
			</select>
			</td>
		<td>Define se ser gerado e enviado um boleto bancrio para o e-mail do cliente de forma automtica e transparente.</td>
	    </tr>
          <tr>
          <td><strong>Prazo do boleto: </strong></td>
              <td>
                <input type="text" size="2" name="PRAZO_BLTO" class="inputbox" value="<?php  echo PRAZO_BLTO ?>" />
		  </td>
          <td>Entre com o prazo de vencimento do boleto bancrio em dias. Ex. 7 dias aps a data atual.</td>
	    </tr>
          <tr>
          <td><strong>Imagem com logotipo:</strong></td>
              <td>
                <input type="text" size="60" name="LOGO_END" class="inputbox" value="<?php  echo LOGO_END ?>" /><br>
		  </td>
          <td>Entre com o caminho para a imagem com seu logotipo que ser exibida na tela final juntamente com o link para gerao do boleto.</td>
	    </tr>
          <tr>
          <td><strong>Dimenses da Imagem:</strong></td>
              <td>
                Altura: <input type="text" size="3" name="LOGO_A" class="inputbox" value="<?php  echo LOGO_A ?>" />&nbsp;&nbsp;&nbsp;
                Largura: <input type="text" size="3" name="LOGO_L" class="inputbox" value="<?php  echo LOGO_L ?>" />
		  </td>
          <td>Entre com as dimenses da imagem em pixels (largura e altura).</td>
	    </tr>

        </table>

<?php
    }

    function has_configuration() {
        // return false if there's no configuration
        return true;
    }

      /**
	* Returns the "is_writeable" status of the configuration file
	* @param void
	* @returns boolean True when the configuration file is writeable, false when not
	*/
     function configfile_writeable() {
        return is_writeable( CLASSPATH."payment/".$this->classname.".cfg.php" );
     }
   
    /**
	* Returns the "is_readable" status of the configuration file
	* @param void
	* @returns boolean True when the configuration file is writeable, false when not
	*/
     function configfile_readable() {
        return is_readable( CLASSPATH."payment/".$this->classname.".cfg.php" );
     }
     
       /**
	* Escreve o arquivo de configurao
	* @param array de objetos :D
	* @returns boolean True se conseguir escrever direitinho
	*/
     function write_configuration( &$d ) {
         
        $my_config_array = array("MAMBOLETO_ID" => $d['MAMBOLETO_ID'],
					   "EMAIL_ID" => $d['EMAIL_ID'],
					   "PRAZO_BLTO" => $d['PRAZO_BLTO'],
					   "LOGO_END" => $d['LOGO_END'],
					   "LOGO_L" => $d['LOGO_L'],
					   "LOGO_A" => $d['LOGO_A']
					);
        $config = "<?php\n";
        $config .= "defined('_VALID_MOS') or die('Direct Access to this location is not allowed.'); \n\n";
        foreach( $my_config_array as $key => $value ) {
          $config .= "define ('$key', '$value');\n";
        }      
        $config .= "?>";
  
        if ($fp = fopen(CLASSPATH ."payment/".$this->classname.".cfg.php", "w")) {
            fputs($fp, $config, strlen($config));
            fclose ($fp);
            return true;
        }
        else
          return false;
     }
     
     /**************************************************************************
    ** name: process_payment()
    ** returns: um cd do Wando
    ***************************************************************************/
    function process_payment($order_number, $order_total, &$d) {
      global $database, $mosConfig_live_site;
      
      
      
      $ps_vendor_id = $_SESSION["ps_vendor_id"];
        $auth = $_SESSION['auth'];
        $ps_checkout = new ps_checkout;
      
      
      /* arquivo de configurao com o id do boleto*/
      require_once(CLASSPATH ."payment/".$this->classname.".cfg.php");
      

      // Get user billing information
      //MOD for Joomla 1.0.8 and virtuemart 1.0.4 by messuka@messuka.com.br
        $dbbt = new ps_DB;
        $qt = "SELECT * FROM `#__{vm}_user_info` WHERE user_id='".$auth["user_id"]."' AND address_type='BT'";
        $dbbt->query($qt);
        $dbbt->next_record();
        $user_info_id = $dbbt->f("user_info_id");
        if( $user_info_id != $d["ship_to_info_id"]) {
            // Get user billing information
            $dbst =& new ps_DB;
            $qt = "SELECT * FROM #__{vm}_user_info WHERE user_info_id='".$d["ship_to_info_id"]."' AND address_type='ST'";
            $dbst->query($qt);
            $dbst->next_record();
        }
        else {
            $dbst = $dbbt;
        }

      $cliente = substr($dbbt->f("first_name"), 0, 25)."&nbsp;".substr($dbbt->f("middle_name"), 0, 25)."&nbsp;".substr($dbbt->f("last_name"), 0, 25);
      $endereco = $dbbt->f("address_1").' - '.$dbbt->f("address_2").' - '.$dbbt->f("city").'-'.$dbbt->f("state").' CEP '.$dbbt->f("zip");

//pega o email do cliente
	$recipiente_email = $dbbt->f("user_email");

      
      /* incompatibilidade com o phpShop. Ele insere na tabela depois que  confirmado o pedido. */
      $sql = "SELECT max(order_id)+1 as order_id FROM #__vm_orders";
      $dados = null;
      $database->setQuery($sql);      
      $database->loadObject($dados);
      
      /* Dados que sero passados */
      $id = MAMBOLETO_ID; // definido na configurao.

      $nosso_numero = $dados->order_id ? $dados->order_id : 1 ;
      $numero_documento = $dados->order_id ? $dados->order_id : 1;
      $valor_documento = "$order_total";

//Data do Pedido e data de vencimento do boleto
	$vencimento = date("d/m/Y", time()+60*60*24*PRAZO_BLTO);
	$data_documento = date("d/m/Y", time());

//monta e formata dados do email
	$boletomail = EMAIL_ID; // definido na configurao.
	$assunto = "Boleto Bancrio - Pedido No. " . $nosso_numero;

// mostra o seu logotipo
// echo '<img src="'.LOGO_END.'" border="0" height="'.LOGO_A.'" width="'.LOGO_L.'"><br><br>';

if (LOGO_END != ""){
echo '<img src="'.LOGO_END.'" border="0" ';
if (LOGO_A != ""){
echo 'height="'.LOGO_A.'" ';
}
if (LOGO_L != ""){
echo 'width="'.LOGO_L.'" ';
}
echo '><br><br>';
}

// envia o boleto por email se opo est habilitada
                  if ($boletomail == "1"){

                     $workstring='option=com_mamboleto'; 
                     $workstring.='&no_html=0'; 
                     $workstring.='&vencimento='.urlencode(@$vencimento); 
                     $workstring.='&nosso_numero='.urlencode(@$nosso_numero); 
                     $workstring.='&numero_documento='.urlencode(@$numero_documento); 
                     $workstring.='&data_documento='.urlencode(@$data_documento); 
                     $workstring.='&valor_documento='.urlencode(@$valor_documento); 
                     $workstring.='&id='.urlencode(@$id); 
                     $workstring.='&numero_documento='.urlencode(@$numero_documento); 
                     $workstring.='&sacado='.urlencode(@$cliente); 
                     $workstring.='&endereco='.urlencode(@$endereco); 
                     $workstring.='&boletomail='.urlencode(@$boletomail); 
                     $workstring.='&assunto='.urlencode(@$assunto); 
                     $workstring.='&recipiente_email='.urlencode(@$recipiente_email); 

                     $uri = "/index2.php";
                     $hostname = $mosConfig_live_site;
                     $hostname = str_replace("http://", "", $hostname);

                     $header = "POST $uri HTTP/1.0\r\n";
                     $header.= "User-Agent: PHP/".phpversion()."\r\n";
                     $header.= "Referer: ".$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'].@$_SERVER['QUERY_STRING']."\r\n";
                     $header.= "Server: ".$_SERVER['SERVER_SOFTWARE']."\r\n";
                     $header.= "Host: ".$hostname.":80\r\n";
                     $header.= "Content-Type: application/x-www-form-urlencoded\r\n";
                     $header.= "Content-Length: ".strlen($workstring)."\r\n";
                     $header.= "Accept: */*\r\n\r\n";

                     $fp = fsockopen ( $hostname, 80, $errno, $errstr, 30);

                     fwrite($fp, $header . $workstring);

                     fclose ($fp);

                     echo "<strong>Ateno:</strong> Um boleto bancrio foi enviado para <strong>$recipiente_email</strong> com sucesso!<br><br>";
                     echo "Voc tambm pode clicar no boto abaixo para imprimir o boleto bancrio.<br><br>";

                  }

//envia os dados por POST para melhorar a segurana

echo '<center>';
echo '<form target="_blank" action="'.$mosConfig_live_site.'/index2.php" method="post">';
echo '<input type="hidden" name="option" value="com_mamboleto" />';
echo '<input type="hidden" name="no_html" value="0" />';
echo '<input type="hidden" name="vencimento" value="'.$vencimento.'" />';
echo '<input type="hidden" name="nosso_numero" value="'.$nosso_numero.'" />';
echo '<input type="hidden" name="numero_documento" value="'.$numero_documento.'" />';
echo '<input type="hidden" name="data_documento" value="'.$data_documento.'" />';
echo '<input type="hidden" name="valor_documento" value="'.$valor_documento.'" />';
echo '<input type="hidden" name="id" value="'.$id.'" />';
echo '<input type="hidden" name="sacado" value="'.$cliente.'" />';
echo '<input type="hidden" name="endereco" value="'.$endereco.'" />';

echo '<input type="image" src="./administrator/components/com_mamboleto/imagens/mamboletop.gif" name="submit" border="0" alt="Emita seu Boleto">';
echo '</form>';
echo '<h5>CLIQUE ACIMA E IMPRIMA SEU BOLETO!</h5>';
echo '</center>';
echo '<br>';

		return true;
    }
}
?>